#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Reciprocal Link Checker (Unix/Linux Operating Systems Only)
# DIZ: Enables you to check if your reciprocal links still exists and if not you can send email to link owners asking them to place your link back.
# GRAPHIC: ic_settings6.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;
use LWP::UserAgent;


&get_setup;
$q = CGI->new;

### FIELD extf3 = reciprocal link

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "check") { &check_recips; }
if ($q->param('fct') eq "check2") { &check_recips2; }
if ($q->param('fct') eq "crawl") { &crawl; }
if ($q->param('fct') eq "populate") { &populate; }
if ($q->param('fct') eq "viewlog") { &viewlog; }



####################################################################################

sub viewlog
{

$lname = "LOG" . $q->param('thread') . ".rcl";

$logfile = acs::get_file_contents("$data_dir/tmp/$lname");

$logfile =~ s/\n/<BR>/g;

print $logfile;


}






sub write_log
{

my ($l_ofile, $ltext) = @_;

open (LFILE, ">> $data_dir/tmp/$l_ofile");
	print LFILE $ltext;
close (LFILE);

}




sub crawl
{

$redirect_html = qq[
<html>
<head>
<title>PowerSeek</title>
<meta http-equiv="refresh" content="5">
</head>
<body>
];


$recip = $q->param('recip');
$perthread = $q->param('perthread');
$curr_thread = $q->param('curr_thread');
$total = $q->param('total');


$limit_start = ($curr_thread * $perthread) - $perthread;

$busy_file = "RECIP" . $curr_thread . ".rcp";
$complete_file = "RECIP" . $curr_thread . ".rcc";
$logfile = "LOG" . $curr_thread . ".rcl";


#### IF COMPLETED 
if ((-e "$data_dir/tmp/$complete_file") > 0)
	{
	print qq[<html>

<head>
<title>Complete!</title>
</head>

<body>

<table border="0" cellspacing="1" width="100%" cellpadding="0" bgcolor="#E5E5E5">
  <tr>
    <td width="20%" bgcolor="#FFFFFF" align="center"><a
    href="$admin_url/p_recip.cgi?fct=viewlog&amp;thread=$curr_thread" target="_blank"><strong><font face="Verdana"
    size="1">View Thread Log</font></strong></a></td>
    <td width="20%" bgcolor="#F7F7F7" align="center"><font face="Verdana" size="1"><strong>100% 
    Complete</strong></font></td>
    <td width="100%" bgcolor="#FFFFFF"><table border="0" cellpadding="0" cellspacing="0"
    width="100%">
      <tr>
        <td width="100%" background="$web_url/bar.gif"><font color="#FCDB56">_</font></td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</body>
</html>
];
	exit;
	}



## IF CHILD ALREADY ACTIVE
if ((-e "$data_dir/tmp/$busy_file") > 0)
	{
	
	open (PFILE, "$data_dir/tmp/$busy_file");
	$p_complete = <PFILE>;
	close (PFILE);
	if ($p_complete =~ /Busy/)
		{
		$p_complete = "0.01";
		}
	
	$p_complete = $p_complete . "%";
	
	print $redirect_html;
		print qq[
					<table border="0" cellspacing="1" width="100%" cellpadding="0" bgcolor="#E5E5E5">
					  <tr>
					    <td width="20%" bgcolor="#FFFFFF" align="center"><img src="$web_url/working2.gif"></td>
					    <td width="20%" bgcolor="#F7F7F7" align="center"><font face="Verdana" size="1"><strong>$p_complete Complete</strong></font></td>
					    <td width="60%" bgcolor="#FFFFFF"><table border="0" cellpadding="0" cellspacing="0" width="$p_complete">
					      <tr>
					        <td width="100%" background="$web_url/bar.gif"><font color="#FCDB56">_</font></td>
					      </tr>
					    </table>
					    </td>
					  </tr>
					</table>
					</body>
					</html>
				];

	}
	else
	{

	defined(my $childpid = fork) or die "Cannot fork: $!";

		if ($childpid) 
			{
				$intr = int(rand(1000));
				print $redirect_html;
				print qq[
				<table border="0" cellspacing="1" width="100%" cellpadding="0" bgcolor="#E5E5E5">
				  <tr>
				    <td width="20%" bgcolor="#FFFFFF" align="center"><img src="$web_url/working2.gif"></td>
				    <td width="20%" bgcolor="#F7F7F7" align="center"><font face="Verdana" size="1"><strong>Initializing...</strong></font></td>
				    <td width="60%" bgcolor="#FFFFFF"><table border="0" cellpadding="0" cellspacing="0" width="0.1%">
				      <tr>
				        <td width="100%" background="$web_url/bar.gif"><font color="#FCDB56">_</font></td>
				      </tr>
				    </table>
				    </td>
				  </tr>
				</table>
				</body>
				</html>
				];
			}
		else
			{
	
			open STDIN, "</dev/null";
			open STDOUT, ">/dev/null";

			open (BFILE, "> $data_dir/tmp/$busy_file");
			print BFILE "Busy";
			close (BFILE);

			
			my $ua = LWP::UserAgent-> new();
			$ua->agent("Mozilla/4.0 (compatible; MSIE 5.5)");

			open (BFILE, "> $data_dir/tmp/$busy_file");
			print BFILE "Busy";
			close (BFILE);

			if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
			$dbh2 = DBI->connect($dsn, $db_username, $db_password);
			if ( !defined $dbh2 ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

			if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
		 	$dbh = DBI->connect($dsn, $db_username, $db_password);
		 	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

			$sql = "SELECT * FROM links WHERE (extf3 IS NOT NULL) AND (extf3 != '') AND (email IS NOT NULL) AND (email != '') LIMIT $limit_start,$perthread";
			$sth = $dbh->prepare($sql);
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
			$rows = $sth->rows();
			$prows = $rows + 1;
			
			
				#### LOG FILE
				&write_log($logfile, "\n\n\n\nSQL Query to Fetch Records: $sql\n");
				&write_log($logfile, "Returned $rows Results\n");
				
			
			### IF THERE IS NOTHING TO DO
				if ($rows < 1) 
					{
					open (BFILE, "> $data_dir/tmp/$complete_file");
					print BFILE "COMPLETED";
					close (BFILE);
					unlink ($data_dir/tmp/$busy_file);
					
						#### LOG FILE
						&write_log($logfile, "\nNothing To Do.. Exiting..\n");
					
					exit(0);
					}


				$perc_counter = 1;
				
				while ( @row = $sth->fetchrow() )
				{
				
				$c_lnkid = $row[0];
				$c_cid = $row[1];
				$c_title = $row[2];
				$c_diz = $row[3];
				$c_url = $row[5];
				$c_email = $row[9];
				
				&write_log($logfile, "Making Connection to: $row[25]\n");
				
				my $req = HTTP::Request->new(GET => "$row[25]"); 
				my $response = $ua->request($req);
					
				$status = $response->status_line;
				$found_recip = "false";
				
					#### LOG FILE
					&write_log($logfile, "Connection Made. Status: $status\n");
				
				if ($response->is_success) 
					{
					
					$page_contents = $response->content();
					if ($page_contents =~ /$recip/i)
						{
						$found_recip = "true";
						&write_log($logfile, "Found Reciprocal Link at: $row[25]\n");
						}
					}
					else
					{
					if (($status =~ /200/) or ($status =~ /404/))
						{
						$not_found_crit = "true";
						&write_log($logfile, "Could Not Find Reciprocal Link at: $row[25]\n");
						}
					
					}
					
					
					
				
				
				###################################################
					
				#if (($found_recip eq "false") and ($not_found_crit eq "true"))
				if ($found_recip eq "false")
					{

					$nowtime = time();
					
					$orig_status = $status;
					
					$c_title = $dbh2->quote($c_title);
					$c_diz = $dbh2->quote($c_diz);
					$c_url = $dbh2->quote($c_url);
					$c_email = $dbh2->quote($c_email);
					$status = $dbh2->quote($status);
					$c_recip = $dbh2->quote($row[25]);
					
					&write_log($logfile, "Could not find Reciprocal Link: $row[25]\n");
		 
		 				### CHECK IF RECORD EXISTS
			 			$sql = "SELECT * FROM reciphist WHERE lnkid = '$c_lnkid'";
						$sth2 = $dbh2->prepare($sql);
						$sth2->execute;
						$serror = ""; $serror = $sth2->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
		 				$foundrows = $sth2->rows();
		 				
		 				if ($foundrows > 0) ### IF EXISTS
		 					{
		 						while ( @frow = $sth2->fetchrow() )
									{
									$reciphistory = $frow[3];
									}
									
									$reciphistory = $reciphistory . $nowtime . ":o:" . $orig_status . ":-:-:";
									$reciphistory = $dbh2->quote($reciphistory);
		 					
						 			$sql = "UPDATE reciphist SET history = $reciphistory, response = $status, checkdate = '$nowtime' WHERE lnkid = '$c_lnkid'";
									$sth2 = $dbh2->prepare($sql);
									$sth2->execute;
									$serror = ""; $serror = $sth2->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
									
									&write_log($logfile, "Updated Reciprocal Link Report that Reciprocal Link could not be found.\n");
		 						 					
		 					}
		 					else
		 					{
		 				
		 					$history_in = $dbh2->quote("$nowtime" . ":o:" . "$orig_status" . ":-:-:");
		 				
							$sql = "INSERT INTO reciphist SET 	lnkid = '$c_lnkid', 
																			cid = '$c_cid',
																			history = $history_in,
																			response = $status,
																			checkdate = '$nowtime',
																			recip = $c_recip,
																			title = $c_title,
																			diz = $c_diz,
																			url = $c_url,
																			email = $c_email
																			";
					
							$sth2 = $dbh2->prepare($sql);
							$sth2->execute;
							$serror = ""; $serror = $sth2->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
							
							&write_log($logfile, "Inserted New Record that Reciprocal Link could not be found.\n");
							}
					
					

					}
					elsif ($found_recip eq "true")
					{
					$sql = "DELETE FROM reciphist WHERE lnkid = '$c_lnkid'";
					$sth2 = $dbh2->prepare($sql);
					$sth2->execute;
					$serror = ""; $serror = $sth2->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

					#### LOG FILE
					&write_log($logfile, "Remove previous reciprocal link history if link owner placed Reciprocal Link back: $c_url\n");
					
					}
				
				#### LOG FILE
				&write_log($logfile, "\n\n\n\n");
				
				### PERC COMPLETE
				$perc_counter++;
				
				$curr_perc = ($perc_counter / $prows) * 100;
				$curr_perc = sprintf("%5.2f",$curr_perc); 
				
				open (BFILE, "> $data_dir/tmp/$busy_file");
					print BFILE "$curr_perc";
				close (BFILE);
				
				}
	
			$sth->finish;
			$dbh->disconnect;
	
			$sth2->finish;
			$dbh2->disconnect;
		
			
		open (BFILE, "> $data_dir/tmp/$complete_file");
		print BFILE "COMPLETED";
		close (BFILE);
		
		unlink ($data_dir/tmp/$busy_file);
	
	exit(0);
	}

}


}





sub check_recips2
{

if ($q->param('url') eq "") { acs::problem_popup("You have to supply a URL to be looked for at the reciprical link of the link owner.");} 
if ($q->param('threads') > 50) { acs::problem_popup("You cannot use more than 50 threads.");} 


opendir(DIR,"$data_dir/tmp");
@files = readdir(DIR);

foreach $filename (@files)
	{
	if (substr($filename, length($filename) - 4, 4) eq ".rcp") ### BUSY FILE
		{ 
		$stat = unlink("$data_dir/tmp/$filename");
		}
		elsif (substr($filename, length($filename) - 4, 4) eq ".rcc") ### COMPLETE FILE
		{ 
		$stat = unlink("$data_dir/tmp/$filename");
		}
		elsif (substr($filename, length($filename) - 4, 4) eq ".rcl") ### LOG FILE
		{ 
		$stat = unlink("$data_dir/tmp/$filename");
		}
		
	}
closedir(DIR);


$recip = $q->param('url');

$threads = $q->param('threads');

	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
 	$dbh = DBI->connect($dsn, $db_username, $db_password);
 	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

	$sql = "SELECT * FROM links WHERE (extf3 IS NOT NULL) AND (extf3 != '') AND (email IS NOT NULL) AND (email != '')";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
	$rows = $sth->rows();



if ($q->param('clear_report') eq "Y")
	{
	$sql = "DELETE FROM reciphist";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: $sql";}
	}




	$sth->finish;
	$dbh->disconnect;


$modp = ($rows % $threads);
$pages = ($rows - $modp) / $threads;
if ($modp != 0) {$pages++;}



$hbox = acs::get_heading_box("$web_url/ic_settings6.gif", "Checking Reciprocal Links", qq[
<p>Found <strong>$rows </strong>links that has reciprocal links. Now checking if the
reciprocal links still exists. </p>

<p><strong>Do not close this window until all the thread processes below has indicated
that they finished. </strong></p>

<p><strong>You can <a href="$admin_url/recip2.cgi">click here </a>to continue after all
processes ended. </strong></p>

<p>If this window is accidentally closed the thread processes will continue until all
reciprocal links has been checked. </p>
]); 








print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>

<body>

$hbox

];



for ($ms = 1; $ms <= $threads; $ms++) 
	{
	print qq[<iframe src="$admin_url/p_recip.cgi?fct=crawl&perthread=$pages&curr_thread=$ms&total=$rows&recip=$recip" width="100%" height="50" frameborder="0"></iframe><BR>];
	}


print qq[
</body>
</html>
];

}





sub check_recips
{

$gsettings = new_gsettings acs; 

$url = $gsettings->{reciprocal_link_back};



$hbox = acs::get_heading_box("$web_url/ic_settings6.gif", "Check For Reciprocal Links", qq[
Check if your link still exists from where users placed a link to your site (reciprocal link) when they submitted their link.
<BR><b><a href="$admin_url/recip2.cgi">Go back</a></b>
]);



print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox



<form method="POST" action="$admin_url/p_recip.cgi">
  <input type="hidden" name="fct" value="check2"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#E5E5E5">
    <tr>
      <td width="100%" height="30" colspan="2" background="$web_url/bar6.gif" bgcolor="#FFE135" class="normaltext"><strong>Connection
      Options: </strong></td>
    </tr>
    <tr>
      <td width="39%" height="30" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Number of threads to
      open: </strong></td>
      <td width="61%" height="30" valign="top" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="threads" size="8" value="10"> (10 recommended - Max 50) <p><strong>Important Note: </strong>A
      high number of threads may place a large burden on processing power and server resources.
      If this is not your own dedicated server then keep this number at 10 or less. </p>
      <p>&nbsp; </td>
    </tr>
    <tr>
      <td width="39%" height="30" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>URL to look for: </strong></td>
      <td width="61%" height="30" valign="top" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="url"
      size="47" value="$url"> <p>This is the URL that will be looked for at the sites where the
      reciprocal links should be. If this URL is not found then the link will be marked and you
      can then choose to send email to this link owner to ask him/her to place your link back. </p>
      <p>&nbsp; </td>
    </tr>
    <tr>
      <td width="39%" height="30" valign="top" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="61%" height="30" valign="top" bgcolor="#FFFFFF" class="normaltext"><input type="checkbox"
      name="clear_report" value="Y"> <strong>Clear Reciprocal Link Report </strong><p>If you
      tick the above box then the previous 'Reciprocal Link Report' will be cleared/removed. It
      is not required that the previous Reciprocal Link Report be cleared/removed. The reason
      for this is that if a Link Owner was mailed previously to place your link back and he did,
      then the existing 'Reciprocal Link Report' will be updated by removing his site/link
      listed as not have a Reciprocal Link. </p>
      <p>&nbsp; </td>
    </tr>
    <tr>
      <td width="39%" height="30" valign="top" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="61%" height="30" valign="top" bgcolor="#FFFFFF" class="normaltext"><input type="submit"
      value="Start Checking" name="B1"> <p>After the this 'Reciprocal Link Checker' has finished
      you will be provided with a report where you can send email to link owners where your
      reciprocal link could not be found. </p>
      <p>&nbsp; </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>



</body>
</html>


];



}







sub start
{


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$wsql = "SHOW TABLES";
$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
while ( @row = $sth->fetchrow() )
	{
	if ($row[0] eq "reciphist") { $tbl_found = "True"; }
	}
 

if ($tbl_found ne "True")
	{

	$sql = "CREATE TABLE reciphist 
				(
				hid				int NOT NULL auto_increment,
				lnkid				int,
				cid				int,
				history			text,
				response			varchar(255),
				checkdate		int,
				recip				varchar(255),
							
				title				varchar(255),
				diz				varchar(255),
				url				varchar(255),
				email				varchar(255),
				
							
				PRIMARY 	KEY(hid),
				INDEX (lnkid), 
				INDEX (cid),
				INDEX (response),
				INDEX (checkdate)
				)  TYPE=MyISAM";
							
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

	} 


$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_settings6_long.gif", "Reciprocal Link Checker", qq[
Enables you to check if your reciprocal link still exist with link owners and if not send them email to put back your reciprocal link.
]);


print qq[<html>

<head>
<title>Reciprocal Link Checker</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
 
</head>

<body>

$hbox

<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#E0E0E0" height="46">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" align="center"><img
    src="$web_url/ic_help.gif"> </td>
    <td width="99%" height="80" bgcolor="#FFFFFF" class="normaltext"><strong><a
    href="$admin_url/recip2.cgi?fct=setup">Setup Instructions </a></strong><br>
    Instructions on enabling Reciprocal Link Checking with PowerSeek. Explains how to require
    a reciprocal link back to your web site when visitors submit a link. </td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" align="center"><p align="center"><img
    src="$web_url/ic_settings6.gif"> </td>
    <td width="99%" height="80" bgcolor="#FFFFFF" class="normaltext"><strong><a href="$admin_url/recip2.cgi">Reciprocal
    Link Checker &amp; Email Functions </a><br>
    </strong>Check if reciprocal links still exists back to your web site and send email to
    link owners who removed your reciprocal link. </td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>
</body>
</html>

];



}



sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

